Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4802)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4803)
@@ -1943,12 +1944,11 @@
                 DO  j = nys, nyn
 !
-!--                Set control flags indicating east- and westward-orientated 
-!--                building edges. Note, building_egde_w is set from the perspective
-!--                of the potential rooftop grid point, while building_edge_e is
-!--                is set from the perspective of the non-building grid point.
-                   building_edge_w = ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )&
-                        .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j,i-1), 6 ) )
-                   building_edge_e = ANY( BTEST( wall_flags_total_0(:,j,i-1), 6 ) )&
-                        .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )
+!--                Set control flags indicating east- and westward-orientated building edges. Note,
+!--                building_egde_w is set from the perspective of the potential rooftop grid point,
+!--                while building_edge_e is set from the perspective of the non-building grid point.
+                   building_edge_w =              ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )   &
+                                     .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j,i-1), 6 ) )
+                   building_edge_e =              ANY( BTEST( wall_flags_total_0(:,j,i-1), 6 ) )   &
+                                     .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )
 !
 !--                Determine topography-top index on u-grid
@@ -1957,16 +1957,14 @@
                       kk = k - topo_top_ind(j,i,1)   !- lad arrays are defined flat
 !
-!--                   In order to create sharp boundaries of the plant canopy, 
-!--                   the lad on the u-grid at index (k,j,i) is equal to lad_s(k,j,i),
-!--                   rather than being interpolated from the surrounding lad_s, 
-!--                   because this would yield smaller lad at the canopy boundaries 
-!--                   than inside of the canopy.
-!--                   For the same reason, the lad at the rightmost(i+1)canopy 
-!--                   boundary on the u-grid equals lad_s(k,j,i), which is considered
-!--                   in the next if-statement. Note, at left-sided building edges 
-!--                   this is not applied, here the LAD is equals the LAD at grid
-!--                   point (k,j,i), in order to avoid that LAD is mistakenly mapped 
-!--                   on top of a roof where (usually) is no LAD is defined. The same is
-!--                   also valid for bad_s.
+!--                   In order to create sharp boundaries of the plant canopy, the lad on the u-grid
+!--                   at index (k,j,i) is equal to lad_s(k,j,i), rather than being interpolated from
+!--                   the surrounding lad_s, because this would yield smaller lad at the canopy
+!--                   boundaries than inside of the canopy.
+!--                   For the same reason, the lad at the rightmost(i+1)canopy boundary on the
+!--                   u-grid equals lad_s(k,j,i), which is considered in the next if-statement.
+!--                   Note, at left-sided building edges this is not applied, here the LAD equals
+!--                   the LAD at grid point (k,j,i), in order to avoid that LAD is mistakenly mapped
+!--                   on top of a roof where (usually) no LAD is defined. The same is also valid for
+!--                   bad_s.
                       lad_local = lad_s(kk,j,i)
                       IF ( lad_local == 0.0_wp  .AND.  lad_s(kk,j,i-1) > 0.0_wp                    &
@@ -1977,9 +1975,8 @@
                            .AND.  .NOT. building_edge_w )  bad_local = bad_s(kk,j,i-1)
 !
-!--                   In order to avoid that LAD is mistakenly considered at right-
-!--                   sided building edges (here the topography-top index for the
-!--                   u-component at index j,i is still on the building while the
-!--                   topography top for the scalar isn't), LAD is taken from grid
-!--                   point (j,i-1). The same is also valid for bad_s.
+!--                   In order to avoid that LAD is mistakenly considered at right-sided building
+!--                   edges (here the topography-top index for the u-component at index j,i is still
+!--                   on the building while the topography top for the scalar isn't), LAD is taken
+!--                   from grid point (j,i-1). The same is also valid for bad_s.
                       IF ( lad_local > 0.0_wp  .AND.  lad_s(kk,j,i-1) == 0.0_wp                    &
                            .AND.  building_edge_e )  lad_local = lad_s(kk,j,i-1)
@@ -1991,18 +1988,18 @@
 !
 !--                   Calculate preliminary value (pre_tend) of the tendency
-                      pre_tend = - canopy_drag_coeff *                         &
-                                   ( lad_local + bad_local ) *                 &
-                                   SQRT( u(k,j,i)**2 +                         &
-                                         ( 0.25_wp * ( v(k,j,i-1) +            &
-                                                       v(k,j,i)   +            &
-                                                       v(k,j+1,i) +            &
-                                                       v(k,j+1,i-1) )          &
-                                         )**2 +                                &
-                                         ( 0.25_wp * ( w(k-1,j,i-1) +          &
-                                                       w(k-1,j,i)   +          &
-                                                       w(k,j,i-1)   +          &
-                                                       w(k,j,i) )              &
-                                         )**2                                  &
-                                       ) *                                     &
+                      pre_tend = - canopy_drag_coeff *                                             &
+                                   ( lad_local + bad_local ) *                                     &
+                                   SQRT( u(k,j,i)**2 +                                             &
+                                         ( 0.25_wp * ( v(k,j,i-1) +                                &
+                                                       v(k,j,i)   +                                &
+                                                       v(k,j+1,i) +                                &
+                                                       v(k,j+1,i-1) )                              &
+                                         )**2 +                                                    &
+                                         ( 0.25_wp * ( w(k-1,j,i-1) +                              &
+                                                       w(k-1,j,i)   +                              &
+                                                       w(k,j,i-1)   +                              &
+                                                       w(k,j,i) )                                  &
+                                         )**2                                                      &
+                                       ) *                                                         &
                                    u(k,j,i)
 
@@ -2013,5 +2010,5 @@
 !--                   Compare sign of old velocity and new preliminary velocity,
 !--                   and in case the signs are different, limit the tendency
-                      IF ( SIGN(pre_u,u(k,j,i)) /= pre_u )  THEN
+                      IF ( SIGN( pre_u,u(k,j,i) ) /= pre_u )  THEN
                          pre_tend = - u(k,j,i) * ddt_3d
                       ENDIF
@@ -2030,12 +2027,12 @@
                 DO  j = nysv, nyn
 !
-!--                Set control flags indicating north- and southward-orientated 
-!--                building edges. Note, building_egde_s is set from the perspective
-!--                of the potential rooftop grid point, while building_edge_n is
-!--                is set from the perspective of the non-building grid point.
-                   building_edge_s = ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )&
-                        .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j-1,i), 6 ) )
-                   building_edge_n = ANY( BTEST( wall_flags_total_0(:,j-1,i), 6 ) )&
-                        .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )
+!--                Set control flags indicating north- and southward-orientated building edges.
+!--                Note, building_egde_s is set from the perspective of the potential rooftop grid
+!--                point, while building_edge_n is set from the perspective of the non-building grid
+!--                point.
+                   building_edge_s =              ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )   &
+                                     .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j-1,i), 6 ) )
+                   building_edge_n =              ANY( BTEST( wall_flags_total_0(:,j-1,i), 6 ) )   &
+                                     .AND.  .NOT. ANY( BTEST( wall_flags_total_0(:,j,i),   6 ) )
 !
 !--                Determine topography-top index on v-grid
@@ -2044,34 +2041,31 @@
                       kk = k - topo_top_ind(j,i,2)   !- lad arrays are defined flat
 !
-!--                   In order to create sharp boundaries of the plant canopy, 
-!--                   the lad on the v-grid at index (k,j,i) is equal to lad_s(k,j,i),
-!--                   rather than being interpolated from the surrounding lad_s, 
-!--                   because this would yield smaller lad at the canopy boundaries 
-!--                   than inside of the canopy.
-!--                   For the same reason, the lad at the northmost(j+1)canopy 
-!--                   boundary on the v-grid equals lad_s(k,j,i), which is considered
-!--                   in the next if-statement. Note, at left-sided building edges 
-!--                   this is not applied, here the LAD is equals the LAD at grid
-!--                   point (k,j,i), in order to avoid that LAD is mistakenly mapped 
-!--                   on top of a roof where (usually) is no LAD is defined. 
+!--                   In order to create sharp boundaries of the plant canopy, the lad on the v-grid
+!--                   at index (k,j,i) is equal to lad_s(k,j,i), rather than being interpolated from
+!--                   the surrounding lad_s, because this would yield smaller lad at the canopy
+!--                   boundaries  than inside of the canopy.
+!--                   For the same reason, the lad at the northmost (j+1) canopy boundary on the
+!--                   v-grid equals lad_s(k,j,i), which is considered in the next if-statement.
+!--                   Note, at left-sided building edges this is not applied, here the LAD equals
+!--                   the LAD at grid point (k,j,i), in order to avoid that LAD is mistakenly mapped
+!--                   on top of a roof where (usually) no LAD is defined.
 !--                   The same is also valid for bad_s.
                       lad_local = lad_s(kk,j,i)
                       IF ( lad_local == 0.0_wp  .AND.  lad_s(kk,j-1,i) > 0.0_wp                    &
-                       .AND.  .NOT. building_edge_s )  lad_local = lad_s(kk,j-1,i)
+                           .AND.  .NOT. building_edge_s )  lad_local = lad_s(kk,j-1,i)
 
                       bad_local = bad_s(kk,j,i)
                       IF ( bad_local == 0.0_wp  .AND.  bad_s(kk,j-1,i) > 0.0_wp                    &
-                       .AND.  .NOT. building_edge_s )  bad_local = bad_s(kk,j-1,i)
-!
-!--                   In order to avoid that LAD is mistakenly considered at right-
-!--                   sided building edges (here the topography-top index for the
-!--                   u-component at index j,i is still on the building while the
-!--                   topography top for the scalar isn't), LAD is taken from grid
-!--                   point (j,i-1). The same is also valid for bad_s.
+                           .AND.  .NOT. building_edge_s )  bad_local = bad_s(kk,j-1,i)
+!
+!--                   In order to avoid that LAD is mistakenly considered at right-sided building
+!--                   edges (here the topography-top index for the u-component at index j,i is still
+!--                   on the building while the topography top for the scalar isn't), LAD is taken
+!--                   from grid point (j,i-1). The same is also valid for bad_s.
                       IF ( lad_local > 0.0_wp  .AND.  lad_s(kk,j-1,i) == 0.0_wp                    &
-                       .AND.  building_edge_n )  lad_local = lad_s(kk,j-1,i)
+                           .AND.  building_edge_n )  lad_local = lad_s(kk,j-1,i)
 
                       IF ( bad_local > 0.0_wp  .AND.  bad_s(kk,j-1,i) == 0.0_wp                    &
-                       .AND.  building_edge_n )  bad_local = bad_s(kk,j-1,i)
+                           .AND.  building_edge_n )  bad_local = bad_s(kk,j-1,i)
 
                       pre_tend = 0.0_wp
@@ -2079,18 +2073,18 @@
 !
 !--                   Calculate preliminary value (pre_tend) of the tendency
-                      pre_tend = - canopy_drag_coeff *                         &
-                                   ( lad_local + bad_local ) *                 &
-                                   SQRT( ( 0.25_wp * ( u(k,j-1,i)   +          &
-                                                       u(k,j-1,i+1) +          &
-                                                       u(k,j,i)     +          &
-                                                       u(k,j,i+1) )            &
-                                         )**2 +                                &
-                                         v(k,j,i)**2 +                         &
-                                         ( 0.25_wp * ( w(k-1,j-1,i) +          &
-                                                       w(k-1,j,i)   +          &
-                                                       w(k,j-1,i)   +          &
-                                                       w(k,j,i) )              &
-                                         )**2                                  &
-                                       ) *                                     &
+                      pre_tend = - canopy_drag_coeff *                                             &
+                                   ( lad_local + bad_local ) *                                     &
+                                   SQRT( ( 0.25_wp * ( u(k,j-1,i)   +                              &
+                                                       u(k,j-1,i+1) +                              &
+                                                       u(k,j,i)     +                              &
+                                                       u(k,j,i+1) )                                &
+                                         )**2 +                                                    &
+                                         v(k,j,i)**2 +                                             &
+                                         ( 0.25_wp * ( w(k-1,j-1,i) +                              &
+                                                       w(k-1,j,i)   +                              &
+                                                       w(k,j-1,i)   +                              &
+                                                       w(k,j,i) )                                  &
+                                         )**2                                                      &
+                                       ) *                                                         &
                                    v(k,j,i)
 
@@ -2099,7 +2093,7 @@
                       pre_v = v(k,j,i) + dt_3d * pre_tend
 !
-!--                   Compare sign of old velocity and new preliminary velocity,
-!--                   and in case the signs are different, limit the tendency
-                      IF ( SIGN(pre_v,v(k,j,i)) /= pre_v )  THEN
+!--                   Compare sign of old velocity and new preliminary velocity, and in case the
+!--                   signs are different, limit the tendency.
+                      IF ( SIGN( pre_v,v(k,j,i) ) /= pre_v )  THEN
                          pre_tend = - v(k,j,i) * ddt_3d
                       ELSE
@@ -2129,21 +2123,19 @@
 !
 !--                   Calculate preliminary value (pre_tend) of the tendency
-                      pre_tend = - canopy_drag_coeff *                         &
-                                   ( 0.5_wp *                                  &
-                                      ( lad_s(kk+1,j,i) + lad_s(kk,j,i) ) +    &
-                                     0.5_wp *                                  &
-                                      ( bad_s(kk+1,j,i) + bad_s(kk,j,i) ) ) *  &
-                                   SQRT( ( 0.25_wp * ( u(k,j,i)   +            &
-                                                       u(k,j,i+1) +            &
-                                                       u(k+1,j,i) +            &
-                                                       u(k+1,j,i+1) )          &
-                                         )**2 +                                &
-                                         ( 0.25_wp * ( v(k,j,i)   +            &
-                                                       v(k,j+1,i) +            &
-                                                       v(k+1,j,i) +            &
-                                                       v(k+1,j+1,i) )          &
-                                         )**2 +                                &
-                                         w(k,j,i)**2                           &
-                                       ) *                                     &
+                      pre_tend = - canopy_drag_coeff *                                             &
+                                   ( 0.5_wp * ( lad_s(kk+1,j,i) + lad_s(kk,j,i) ) +                &
+                                     0.5_wp * ( bad_s(kk+1,j,i) + bad_s(kk,j,i) ) ) *              &
+                                   SQRT( ( 0.25_wp * ( u(k,j,i)   +                                &
+                                                       u(k,j,i+1) +                                &
+                                                       u(k+1,j,i) +                                &
+                                                       u(k+1,j,i+1) )                              &
+                                         )**2 +                                                    &
+                                         ( 0.25_wp * ( v(k,j,i)   +                                &
+                                                       v(k,j+1,i) +                                &
+                                                       v(k+1,j,i) +                                &
+                                                       v(k+1,j+1,i) )                              &
+                                         )**2 +                                                    &
+                                         w(k,j,i)**2                                               &
+                                       ) *                                                         &
                                    w(k,j,i)
 !
@@ -2151,7 +2143,7 @@
                       pre_w = w(k,j,i) + dt_3d * pre_tend
 !
-!--                   Compare sign of old velocity and new preliminary velocity,
-!--                   and in case the signs are different, limit the tendency
-                      IF ( SIGN(pre_w,w(k,j,i)) /= pre_w )  THEN
+!--                   Compare sign of old velocity and new preliminary velocity, and in case the
+!--                   signs are different, limit the tendency
+                      IF ( SIGN( pre_w,w(k,j,i) ) /= pre_w )  THEN
                          pre_tend = - w(k,j,i) * ddt_3d
                       ELSE
@@ -2169,5 +2161,5 @@
 !--       potential temperature
           CASE ( 4 )
-             IF ( humidity ) THEN
+             IF ( humidity )  THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -2202,22 +2194,22 @@
                       kk = k - topo_top_ind(j,i,0)   !- lad arrays are defined flat
 
-                      IF ( .NOT. plant_canopy_transpiration ) THEN
+                      IF ( .NOT. plant_canopy_transpiration )  THEN
                          ! pcm_transpiration_rate is calculated in radiation model
                          ! in case of plant_canopy_transpiration = .T.
                          ! to include also the dependecy to the radiation
                          ! in the plant canopy box
-                         pcm_transpiration_rate(kk,j,i) =  - leaf_scalar_exch_coeff &
-                                          * lad_s(kk,j,i) *                         &
-                                          SQRT( ( 0.5_wp * ( u(k,j,i) +             &
-                                                             u(k,j,i+1) )           &
-                                                )**2 +                              &
-                                                ( 0.5_wp * ( v(k,j,i) +             &
-                                                             v(k,j+1,i) )           &
-                                                )**2 +                              &
-                                                ( 0.5_wp * ( w(k-1,j,i) +           &
-                                                             w(k,j,i) )             &
-                                                )**2                                &
-                                              ) *                                   &
-                                          ( q(k,j,i) - leaf_surface_conc )
+                         pcm_transpiration_rate(kk,j,i) = - leaf_scalar_exch_coeff                 &
+                                                            * lad_s(kk,j,i) *                      &
+                                                            SQRT( ( 0.5_wp * ( u(k,j,i) +          &
+                                                                               u(k,j,i+1) )        &
+                                                                  )**2 +                           &
+                                                                  ( 0.5_wp * ( v(k,j,i) +          &
+                                                                               v(k,j+1,i) )        &
+                                                                  )**2 +                           &
+                                                                  ( 0.5_wp * ( w(k-1,j,i) +        &
+                                                                               w(k,j,i) )          &
+                                                                  )**2                             &
+                                                                ) *                                &
+                                                            ( q(k,j,i) - leaf_surface_conc )
                       ENDIF
 
@@ -2237,21 +2229,20 @@
 
                       kk = k - topo_top_ind(j,i,0)   !- lad arrays are defined flat
-                      tend(k,j,i) = tend(k,j,i) -                              &
-                                       2.0_wp * canopy_drag_coeff *            &
-                                       ( lad_s(kk,j,i) + bad_s(kk,j,i) ) *     &
-                                       SQRT( ( 0.5_wp * ( u(k,j,i) +           &
-                                                          u(k,j,i+1) )         &
-                                             )**2 +                            &
-                                             ( 0.5_wp * ( v(k,j,i) +           &
-                                                          v(k,j+1,i) )         &
-                                             )**2 +                            &
-                                             ( 0.5_wp * ( w(k,j,i) +           &
-                                                          w(k+1,j,i) )         &
-                                             )**2                              &
-                                           ) *                                 &
-                                       e(k,j,i)
+                      tend(k,j,i) = tend(k,j,i) -  2.0_wp * canopy_drag_coeff *                    &
+                                                   ( lad_s(kk,j,i) + bad_s(kk,j,i) ) *             &
+                                                   SQRT( ( 0.5_wp * ( u(k,j,i) +                   &
+                                                                      u(k,j,i+1) )                 &
+                                                         )**2 +                                    &
+                                                         ( 0.5_wp * ( v(k,j,i) +                   &
+                                                                      v(k,j+1,i) )                 &
+                                                         )**2 +                                    &
+                                                         ( 0.5_wp * ( w(k,j,i) +                   &
+                                                                      w(k+1,j,i) )                 &
+                                                         )**2                                      &
+                                                       ) *                                         &
+                                                   e(k,j,i)
                    ENDDO
                 ENDDO
-             ENDDO 
+             ENDDO
 !
 !--       scalar concentration
@@ -2264,21 +2255,20 @@
 
                       kk = k - topo_top_ind(j,i,0)   !- lad arrays are defined flat
-                      tend(k,j,i) = tend(k,j,i) -                              &
-                                       leaf_scalar_exch_coeff *                &
-                                       lad_s(kk,j,i) *                         &
-                                       SQRT( ( 0.5_wp * ( u(k,j,i) +           &
-                                                          u(k,j,i+1) )         &
-                                             )**2 +                            &
-                                             ( 0.5_wp * ( v(k,j,i) +           &
-                                                          v(k,j+1,i) )         &
-                                             )**2 +                            &
-                                             ( 0.5_wp * ( w(k-1,j,i) +         & 
-                                                          w(k,j,i) )           &
-                                             )**2                              &
-                                           ) *                                 &
-                                       ( s(k,j,i) - leaf_surface_conc )
+                      tend(k,j,i) = tend(k,j,i) -  leaf_scalar_exch_coeff *                        &
+                                                   lad_s(kk,j,i) *                                 &
+                                                   SQRT( ( 0.5_wp * ( u(k,j,i) +                   &
+                                                                      u(k,j,i+1) )                 &
+                                                         )**2 +                                    &
+                                                         ( 0.5_wp * ( v(k,j,i) +                   &
+                                                                      v(k,j+1,i) )                 &
+                                                         )**2 +                                    &
+                                                         ( 0.5_wp * ( w(k-1,j,i) +                 &
+                                                                      w(k,j,i) )                   &
+                                                         )**2                                      &
+                                                       ) *                                         &
+                                                   ( s(k,j,i) - leaf_surface_conc )
                    ENDDO
                 ENDDO
-             ENDDO    
+             ENDDO
 
 
@@ -2287,5 +2277,5 @@
 
              WRITE( message_string, * ) 'wrong component: ', component
-             CALL message( 'pcm_tendency', 'PA0279', 1, 2, 0, 6, 0 ) 
+             CALL message( 'pcm_tendency', 'PA0279', 1, 2, 0, 6, 0 )
 
        END SELECT
